package com.annimon.ownlang;

import com.annimon.ownlang.lexer.TokenType;
import com.annimon.ownlang.parser.OwnLangCompletionHandler;
import com.annimon.ownlang.parser.OwnLangParser;
import org.netbeans.api.lexer.Language;
import org.netbeans.modules.csl.api.CodeCompletionHandler;
import org.netbeans.modules.csl.api.Formatter;
import org.netbeans.modules.csl.spi.DefaultLanguageConfig;
import org.netbeans.modules.csl.spi.LanguageRegistration;
import org.netbeans.modules.parsing.spi.Parser;

/**
 *
 * @author aNNiMON
 */
@LanguageRegistration(mimeType = "text/x-ownlang")
public final class OwnLang extends DefaultLanguageConfig {
    
    public static final String MIMETYPE = "text/x-ownlang";

    @Override
    public Language<TokenType> getLexerLanguage() {
        return TokenType.getLanguage();
    }
    
    @Override
    public Formatter getFormatter() {
        return super.getFormatter();
    }

    @Override
    public String getDisplayName() {
        return "OwnLang";
    }

    @Override
    public String getPreferredExtension() {
        return "own";
    }
    
    @Override
    public CodeCompletionHandler getCompletionHandler() {
        /**
         * https://github.com/GeertjanWielenga/NetCeylonBeans/tree/b713e7ff88cf53cadad56d1fdb6eecc912301082/NetCeylonBeans/src/org/ncb
         * https://github.com/iconmaster5326/SourceNetbeansPlugin/tree/master/src/com/iconmaster/srcplugin/sample
         */
        return new OwnLangCompletionHandler();
    }

    @Override
    public String getLineCommentPrefix() {
        return "//";
    }

    @Override
    public Parser getParser() {
        return new OwnLangParser();
    }
}
