package com.annimon.ownlang.lexer;

import org.netbeans.api.lexer.Token;
import org.netbeans.spi.lexer.Lexer;
import org.netbeans.spi.lexer.LexerInput;
import org.netbeans.spi.lexer.LexerRestartInfo;
import org.netbeans.spi.lexer.TokenFactory;

/**
 *
 * @author aNNiMON
 */
public final class OwnLangLexer implements Lexer<TokenType> {

    private final LexerRestartInfo<TokenType> info;
    private final TokenFactory<TokenType> tokenFactory;
    
    private boolean isInitialized;
    private com.annimon.ownlang.lexer.Lexer lexer;
    
    public OwnLangLexer(LexerRestartInfo<TokenType> info) {
        this.info = info;
        tokenFactory = info.tokenFactory();
        isInitialized = false;
    }
    
    @Override
    public Token<TokenType> nextToken() {
        if (!isInitialized) {
            synchronized (this) {
                if (!isInitialized) {
                    lexer = new com.annimon.ownlang.lexer.Lexer(readAll(info.input()));
                    isInitialized = true;
                }
            }
        }
        if (info.input().readLength() < 1) {
            return null;
        }
        com.annimon.ownlang.lexer.Token token = lexer.nextToken();
        return tokenFactory.createToken(token.getType(), token.getLength());
    }

    @Override
    public Object state() {
        return null;
    }

    @Override
    public void release() {
    }
    
    private String readAll(final LexerInput input) {
        final StringBuilder sb = new StringBuilder();
        int i;
        while ((i = input.read()) != -1) {
            sb.append((char)i);
        }
        return sb.toString();
    }

}
