package com.annimon.ownlang.lexer;

import org.netbeans.api.lexer.Language;
import org.netbeans.api.lexer.TokenId;

/**
 *
 * @author aNNiMON
 */
public enum TokenType implements TokenId {
    EOF("whitespace"),
    WHITESPACE("whitespace"),
    
    SINGLE_LINE_COMMENT("comment"),
    MULTI_LINE_COMMENT("comment"),
    
    NUMBER("number"),
    HEX_NUMBER("number"),
    WORD("identifier"),
    TEXT("string"),
    
    PRINT("keyword"),
    PRINTLN("keyword"),
    IF("keyword"),
    ELSE("keyword"),
    WHILE("keyword"),
    FOR("keyword"),
    DO("keyword"),
    BREAK("keyword"),
    CONTINUE("keyword"),
    DEF("keyword"),
    RETURN("keyword"),
    USE("keyword"),
    MATCH("keyword"),
    CASE("keyword"),
    EXTRACT("keyword"),
    INCLUDE("keyword"),
    
    PLUS("operator"),
    MINUS("operator"),
    STAR("operator"),
    SLASH("operator"),
    PERCENT("operator"),
    
    EQ("operator"),
    EQEQ("operator"),
    EXCL("operator"),
    EXCLEQ("operator"),
    LT("operator"),
    LTEQ("operator"),
    GT("operator"),
    GTEQ("operator"),
    
    PLUSEQ("operator"),
    MINUSEQ("operator"),
    STAREQ("operator"),
    SLASHEQ("operator"),
    PERCENTEQ("operator"),
    AMPEQ("operator"),
    CARETEQ("operator"),
    BAREQ("operator"),
    COLONCOLONEQ("operator"),
    LTLTEQ("operator"),
    GTGTEQ("operator"),
    GTGTGTEQ("operator"),
    
    PLUSPLUS("operator"),
    MINUSMINUS("operator"),
    
    LTLT("operator"),
    GTGT("operator"),
    GTGTGT("operator"),
    
    TILDE("operator"),
    CARET("operator"),
    BAR("operator"),
    BARBAR("operator"),
    AMP("operator"),
    AMPAMP("operator"),
    
    QUESTION("operator"),
    COLON("operator"),
    COLONCOLON("operator"),
    
    LPAREN("operator"),
    RPAREN("operator"),
    LBRACKET("operator"),
    RBRACKET("operator"),
    LBRACE("operator"),
    RBRACE("operator"),
    COMMA("operator"),
    DOT("operator");
    
    private final String name;

    TokenType(String name) {
        this.name = name;
    }
    
    @Override
    public String primaryCategory() {
        return name;
    }

    public static Language<TokenType> getLanguage() {
        return new OwnLangHierarchy().language();
    }
}
