package com.annimon.ownlang.parser;

import java.util.Objects;
import org.netbeans.modules.csl.api.ElementKind;

public class Identifier {
    private final String name;
    private final ElementKind kind;

    public Identifier(String name, ElementKind kind) {
        this.name = name;
        this.kind = kind;
    }

    public String getName() {
        return name;
    }

    public ElementKind getKind() {
        return kind;
    }

    @Override
    public int hashCode() {
        return Objects.hash(name, kind);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) return true;
        if (obj == null) return false;
        if (getClass() != obj.getClass())
            return false;
        final Identifier other = (Identifier) obj;
        if (this.kind != other.kind)
            return false;
        if (!Objects.equals(this.name, other.name))
            return false;
        return true;
    }

    @Override
    public String toString() {
        return name + " [" + kind + ']';
    }
}