package com.annimon.ownlang.parser;

import java.util.Collections;
import java.util.Set;
import javax.swing.ImageIcon;
import org.netbeans.api.annotations.common.StaticResource;
import org.netbeans.modules.csl.api.ElementHandle;
import org.netbeans.modules.csl.api.ElementKind;
import org.netbeans.modules.csl.api.HtmlFormatter;
import org.netbeans.modules.csl.api.Modifier;
import org.netbeans.modules.csl.spi.DefaultCompletionProposal;
import org.openide.util.ImageUtilities;

public final class OwnLangCompletionProposal extends DefaultCompletionProposal {
    
    @StaticResource
    private static final String OWNLANG_ICON_PATH = "com/annimon/ownlang/filetype/ownlang.png";
    
    private final ElementHandle element;
    private final Set<Modifier> modifiers;

    public OwnLangCompletionProposal(ElementHandle element) {
        this.element = element;
        this.elementKind = element.getKind();
        this.modifiers = element.getModifiers();
    }
    
    @Override
    public ElementHandle getElement() {
        return element;
    }

    /*@Override
    public ElementKind getKind() {
        return elementKind;
    }*/
    
    @Override
    public ImageIcon getIcon() {
        if (element.getKind() == ElementKind.KEYWORD) {
            return ImageUtilities.loadImageIcon(OWNLANG_ICON_PATH, false);
        }
        return null;
    }

    @Override
    public String getName() {
        return element.getName();
    }

    @Override
    public Set<Modifier> getModifiers() {
        return Collections.unmodifiableSet(modifiers);
    }
    
    /*@Override
    public String getCustomInsertTemplate() {
        return null;
    }

    @Override
    public String getLhsHtml(HtmlFormatter formatter) {
        formatter.name(getKind(), true);
        formatter.appendText(getName());
        formatter.name(getKind(), false);
        return formatter.getText();
    }*/
    
    
}
