package com.annimon.ownlang.parser;

import java.util.Collections;
import java.util.List;
import org.netbeans.modules.csl.api.Error;
import org.netbeans.modules.csl.spi.ParserResult;
import org.netbeans.modules.parsing.api.Snapshot;
import org.netbeans.modules.parsing.spi.ParseException;

public final class OwnLangParserResult extends ParserResult {
    
    private final Parser parser;
    private boolean valid = true;

    public OwnLangParserResult(Snapshot snapshot, Parser parser) {
        super(snapshot);
        this.parser = parser;
    }

    public Parser getParser() throws ParseException {
        if (!valid) {
            throw new ParseException();
        }
        return parser;
    }
    
    @Override
    public List<? extends Error> getDiagnostics() {
        return Collections.EMPTY_LIST;
    }

    @Override
    protected void invalidate() {
        valid = false;
    }
    
}
